(*******************************************************************)
(*******************        GOUWY Lucas        *********************)
(*******************      Cr le 16/01/09     *********************)
(*******************   Dernire MJ: 17/01/09  *********************)
(*******************************************************************)
(**  Module contenant la dfinition d'un type Identite:           **) 
(**  - la dfinition du type                                      **)
(**  - un constructeur                                            **)
(**  - des accesseurs                                             **)
(**  - et des fonctions pour travailler sur le type               **)
(*******************************************************************)

type identite = string * string * int(* On cr un type identit *)

(* Le constructeur : *)
let creerIdentite = fun (nom, prenom, age) ->
(* Constructeur du type identite, reoit un n-uplet de type string*string*int et retourne une identite *)
    (nom, prenom, age)

(*Des accesseurs permettant d'accder au nom, au prenom et  l'age: *)

let nom = fun (nom, prenom, age) -> nom 

let prenom = fun (nom, prenom, age) -> prenom 

let age = fun (nom, prenom, age) -> age 

(*Des fonctions pour manipuler le type : *)

let nouveauNom = fun mon_identite new_nom -> 
    (* Fonction qui permet de changer de nom *)
    creerIdentite(new_nom, prenom mon_identite, age mon_identite)

let nouveauPrenom = fun mon_identite new_prenom ->
    (* Fonction qui permet de changer de nom *)
	creerIdentite (nom mon_identite, new_prenom, age mon_identite)
	
let nouvelAge = fun mon_identite new_age ->
    (* Fonction qui permet de changer d'age *)

let majeur = fun mon_identite ->
(* Fonction qui reoit une identite et qui renvoie true si l'age est suprieur o gal  18, donc si on est 
majeur. *)
    (age mon_identite) >= 18

let quandMajeur = fun mon_identite -> 
(* Fonction qui reoit une identite et, si on est majeur, renvoie une erreur, sinon, retourne un entier: dans 
combien de temps on est majeur. *)
    if (majeur mon_identite) = true then failwith "Vous etes deja majeurs !"
	else 18 - (age mon_identite)
	

